/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 * 
 *  DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 *  This code is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License version 3, 
 *  or (at your option) any later version, as published by the Free Software Foundation.  
 *  The authors designate this particular file as subject to the "Classpath" exception 
 *  as provided in the LICENSE file that accompanied this code.
 *
 *  This code is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  version 3 for more details (a copy is included in the LICENSE file that
 *  accompanied this code).
 *
 *  You should have received a copy of the GNU General Public License version 3
 *  along with this work; if not, see http://www.gnu.org/licenses/gpl-3.0.txt 
 *
 *  Please contact visnow.org or visit www.visnow.org if you need additional information or
 *  have any questions.
 *
 */

package org.visnow.vn.lib.basic.mappers.ConnectedComponents;

import java.awt.Container;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.Point;
import java.awt.Rectangle;
import java.util.Hashtable;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JViewport;
import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableColumn;
import org.visnow.vn.engine.core.ParameterProxy;
import org.visnow.vn.engine.core.Parameters;
import org.visnow.vn.gui.widgets.RunButton.RunState;
import static org.visnow.vn.lib.basic.mappers.ConnectedComponents.ConnectedComponentsShared.*;

/**
 *
 * @author Krzysztof S. Nowinski, University of Warsaw, ICM
 */
public class GUI extends JPanel
{
    private Hashtable<Integer, JLabel> downLabels = new Hashtable<>();
    private final int[] scale = {0, 2, 5, 10, 20, 50, 100, 200, 500, 1000, 2000, 5000, 10000};
    private final String[] downTexts = {"0", "", "", "10", "", "", "100", "", "", "1000", "", "", "10000"};
    private static final String[] tableHeader = new String[]{"component name", "size", " "};
    private final DefaultTableModel componentModel;
    private Object[][] tableContent = null;
    private Parameters parameters;
    public static Cursor resizeCursor = Cursor.getPredefinedCursor(Cursor.E_RESIZE_CURSOR);
    private int mouseXOffset;
    private Cursor otherCursor = resizeCursor;

    /**
     * Creates new form SurfaceComponentsUI
     */
    public GUI()
    {
        initComponents();
        componentModel = (DefaultTableModel) componentTable.getModel();
        componentModel.addTableModelListener(new TableModelListener()
        {
            @Override
            public void tableChanged(TableModelEvent e)
            {
                int row = e.getFirstRow();
                if (row >= 0 && row < componentTable.getRowCount() && parameters.get(COMPONENT_NAMES).length == componentTable.getRowCount()) { //TODO: change parameters.get() na nComponents
                    boolean[] modifiedSelection = parameters.get(MODIFIED_SELECTION);
                    modifiedSelection[row] = (boolean) componentTable.getValueAt(row, 2);
                    String[] componentsNames = parameters.get(COMPONENT_NAMES);
                    componentsNames[row] = (String) componentTable.getValueAt(row, 0);
                    parameters.set(COMPONENT_NAMES, componentsNames,
                                   MODIFIED_SELECTION, modifiedSelection,
                                   MODIFIED_COMPONENT, row);
                    runButton.setPendingIfNoAuto();
                }
            }
        });
        for (int i = 0; i < downTexts.length; i++) {
            downLabels.put(i, new JLabel(downTexts[i]));
            downLabels.get(i).setFont(new java.awt.Font("Dialog", 0, 8));
        }
        minSizeSlider.setLabelTable(downLabels);
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        minSizeSlider = new javax.swing.JSlider();
        maxComponentsSlider = new org.visnow.vn.gui.widgets.EnhancedIntSlider();
        componentTable = new javax.swing.JTable();
        runButton = new org.visnow.vn.gui.widgets.RunButton();

        setVerifyInputWhenFocusTarget(false);
        setLayout(new java.awt.GridBagLayout());

        minSizeSlider.setMajorTickSpacing(1);
        minSizeSlider.setMaximum(12);
        minSizeSlider.setPaintLabels(true);
        minSizeSlider.setPaintTicks(true);
        minSizeSlider.setValue(3);
        minSizeSlider.setBorder(javax.swing.BorderFactory.createTitledBorder("minimum component size"));
        minSizeSlider.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                minSizeSliderStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        add(minSizeSlider, gridBagConstraints);

        maxComponentsSlider.setBorder(javax.swing.BorderFactory.createTitledBorder("max shown components"));
        maxComponentsSlider.setVal(20);
        maxComponentsSlider.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                maxComponentsSliderStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        add(maxComponentsSlider, gridBagConstraints);

        componentTable.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(153, 153, 153)));
        componentTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null}
            },
            new String [] {
                "component name", "size", ""
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.Integer.class, java.lang.Boolean.class
            };
            boolean[] canEdit = new boolean [] {
                true, false, true
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        componentTable.setOpaque(false);
        componentTable.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
            public void mouseMoved(java.awt.event.MouseEvent evt) {
                componentTableMouseMoved(evt);
            }
            public void mouseDragged(java.awt.event.MouseEvent evt) {
                componentTableMouseDragged(evt);
            }
        });
        componentTable.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                componentTableMousePressed(evt);
            }
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                componentTableMouseReleased(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 2, 2);
        add(componentTable, gridBagConstraints);

        runButton.addUserActionListener(new org.visnow.vn.gui.swingwrappers.UserActionListener() {
            public void userChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt) {
                runButtonUserChangeAction(evt);
            }
            public void userAction(org.visnow.vn.gui.swingwrappers.UserEvent evt) {
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        add(runButton, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void minSizeSliderStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_minSizeSliderStateChanged
    {//GEN-HEADEREND:event_minSizeSliderStateChanged
        if (!minSizeSlider.getValueIsAdjusting()) {
            parameters.set(MIN_COMPONENT_SIZE, scale[minSizeSlider.getValue()]);
            runButton.setPendingIfNoAuto();
        }
    }//GEN-LAST:event_minSizeSliderStateChanged

    private void maxComponentsSliderStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_maxComponentsSliderStateChanged
    {//GEN-HEADEREND:event_maxComponentsSliderStateChanged
        if(maxComponentsSlider.getVal() < 1)
            maxComponentsSlider.setVal(1);
        if (!maxComponentsSlider.isAdjusting()) {
            parameters.set(SEPARATE_COMPONENTS, maxComponentsSlider.getVal());
            runButton.setPendingIfNoAuto();
        }
    }//GEN-LAST:event_maxComponentsSliderStateChanged

    private void componentTableMousePressed(java.awt.event.MouseEvent evt)//GEN-FIRST:event_componentTableMousePressed
    {//GEN-HEADEREND:event_componentTableMousePressed
        componentTable.getTableHeader().setDraggedColumn(null);
        componentTable.getTableHeader().setResizingColumn(null);
        componentTable.getTableHeader().setDraggedDistance(0);

        Point point = evt.getPoint();

        // First find which header cell was hit   
        int index = componentTable.columnAtPoint(point);
        if (index == -1)
            return;

        // The last 3 pixels + 3 pixels of next column are for resizing   
        TableColumn resizingColumn = getResizingColumn(point, index);
        if (!canResize(resizingColumn))
            return;

        componentTable.getTableHeader().setResizingColumn(resizingColumn);
        if (componentTable.getTableHeader().getComponentOrientation().isLeftToRight())
            mouseXOffset = point.x - resizingColumn.getWidth();
        else
            mouseXOffset = point.x + resizingColumn.getWidth();
    }//GEN-LAST:event_componentTableMousePressed

    private void componentTableMouseMoved(java.awt.event.MouseEvent evt)//GEN-FIRST:event_componentTableMouseMoved
    {//GEN-HEADEREND:event_componentTableMouseMoved
        if (canResize(getResizingColumn(evt.getPoint())) != (componentTable.getCursor() == resizeCursor)) {
            swapCursor();
        }
    }//GEN-LAST:event_componentTableMouseMoved

    private void componentTableMouseDragged(java.awt.event.MouseEvent evt)//GEN-FIRST:event_componentTableMouseDragged
    {//GEN-HEADEREND:event_componentTableMouseDragged
        int mouseX = evt.getX();
        TableColumn resizingColumn = componentTable.getTableHeader().getResizingColumn();
        boolean headerLeftToRight = componentTable.getTableHeader().getComponentOrientation().isLeftToRight();

        if (resizingColumn != null) {
            int oldWidth = resizingColumn.getWidth();
            int newWidth;
            if (headerLeftToRight) {
                newWidth = mouseX - mouseXOffset;
            } else {
                newWidth = mouseXOffset - mouseX;
            }
            resizingColumn.setWidth(newWidth);

            Container container;
            if ((componentTable.getTableHeader().getParent() == null) ||
                    ((container = componentTable.getTableHeader().getParent().getParent()) == null) ||
                    !(container instanceof JScrollPane)) {
                return;
            }

            if (!container.getComponentOrientation().isLeftToRight() &&
                    !headerLeftToRight) {
                if (componentTable != null) {
                    JViewport viewport = ((JScrollPane) container).getViewport();
                    int viewportWidth = viewport.getWidth();
                    int diff = newWidth - oldWidth;
                    int newHeaderWidth = componentTable.getWidth() + diff;

                    /* Resize a table */
                    Dimension tableSize = componentTable.getSize();
                    tableSize.width += diff;
                    componentTable.setSize(tableSize);

                    if ((newHeaderWidth >= viewportWidth) && (componentTable.getAutoResizeMode() == JTable.AUTO_RESIZE_OFF)) {
                        Point point = viewport.getViewPosition();
                        point.x = Math.max(0, Math.min(newHeaderWidth - viewportWidth, point.x + diff));
                        viewport.setViewPosition(point);

                        mouseXOffset += diff;
                    }
                }
            }
        }
    }//GEN-LAST:event_componentTableMouseDragged

    private void componentTableMouseReleased(java.awt.event.MouseEvent evt)//GEN-FIRST:event_componentTableMouseReleased
    {//GEN-HEADEREND:event_componentTableMouseReleased
        componentTable.getTableHeader().setResizingColumn(null);
        componentTable.getTableHeader().setDraggedColumn(null);
    }//GEN-LAST:event_componentTableMouseReleased

    private void runButtonUserChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)//GEN-FIRST:event_runButtonUserChangeAction
    {//GEN-HEADEREND:event_runButtonUserChangeAction
        parameters.set(RUNNING_MESSAGE, (RunState) evt.getEventData());
    }//GEN-LAST:event_runButtonUserChangeAction

    private boolean canResize(TableColumn column)
    {
        return column != null &&
                componentTable.getTableHeader().getResizingAllowed() &&
                column.getResizable();
    }

    private TableColumn getResizingColumn(Point p)
    {
        return getResizingColumn(p, componentTable.columnAtPoint(p));
    }

    private TableColumn getResizingColumn(Point point, int columnInndexRev)
    {
        if (columnInndexRev == -1) {
            return null;
        }
        int row = componentTable.rowAtPoint(point);
        if (row == -1)
            return null;
        Rectangle r = componentTable.getCellRect(row, columnInndexRev, true);
        r.grow(-3, 0);
        if (r.contains(point))
            return null;

        int midPoint = r.x + r.width / 2;
        int columnIndex;
        if (componentTable.getTableHeader().getComponentOrientation().isLeftToRight())
            columnIndex = (point.x < midPoint) ? columnInndexRev - 1 : columnInndexRev;
        else
            columnIndex = (point.x < midPoint) ? columnInndexRev : columnInndexRev - 1;

        if (columnIndex == -1)
            return null;
        return componentTable.getTableHeader().getColumnModel().getColumn(columnIndex);
    }

    private void swapCursor()
    {
        Cursor tmp = componentTable.getCursor();
        componentTable.setCursor(otherCursor);
        otherCursor = tmp;
    }

    public void updateComponentTable(ParameterProxy p)
    {
        int nCellSets = p.get(COMPONENT_NAMES).length;
        int selectRow = -1;
        if (nCellSets < 1)
            return;
        tableContent = new Object[nCellSets][3];
        for (int i = 0; i < nCellSets; i++) {
            tableContent[i][0] = p.get(COMPONENT_NAMES)[i];
            if (tableContent[i][0].equals(p.get(META_CELLSET_MODIFIED_NAME)))
                selectRow = i;
            tableContent[i][1] = "" + p.get(META_CELLSET_COMPONENT_ACTIVE_N_NODES)[i];
            tableContent[i][2] = p.get(MODIFIED_SELECTION)[i];
        }
        int[] columnWidths = new int[3];
        for (int i = 0; i < columnWidths.length; i++) {
            columnWidths[i] = componentTable.getColumnModel().getColumn(i).getWidth();
        }
        componentModel.setDataVector(tableContent, tableHeader);
        componentTable.getColumnModel().getColumn(0).setPreferredWidth(columnWidths[0]);
        componentTable.getColumnModel().getColumn(1).setPreferredWidth(columnWidths[1]);
        componentTable.getColumnModel().getColumn(2).setPreferredWidth(columnWidths[2]);
        if (selectRow >= 0 && selectRow < componentTable.getRowCount()) {
            componentTable.setRowSelectionInterval(selectRow, selectRow);
        }
        componentTable.repaint();
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTable componentTable;
    private org.visnow.vn.gui.widgets.EnhancedIntSlider maxComponentsSlider;
    private javax.swing.JSlider minSizeSlider;
    private org.visnow.vn.gui.widgets.RunButton runButton;
    // End of variables declaration//GEN-END:variables

    void setParameters(Parameters parameters)
    {
        this.parameters = parameters;
    }

    void updateGUI(ParameterProxy p, boolean reset, boolean setRunButtonPending)
    {
        if (p.get(MIN_COMPONENT_SIZE) == 0)
            minSizeSlider.setValue(0);
        else
            minSizeSlider.setValue((int) Math.round((Math.log10((int)p.get(MIN_COMPONENT_SIZE)) * 3.f)));
        maxComponentsSlider.setVal(p.get(SEPARATE_COMPONENTS));

        if (reset) {
            if (!p.get(META_DIFFERENT_PARAMS)) {
                maxComponentsSlider.setMin(1);
                maxComponentsSlider.setMax(Math.max(100, p.get(SEPARATE_COMPONENTS)));
            } else {
                updateComponentTable(p);
            }
        }
        runButton.updateAutoState(p.get(RUNNING_MESSAGE));
        runButton.updatePendingState(setRunButtonPending);
    }

}
